<?php

/**
 * @file
 * FFLM preloader field handler. 
 */

class fflm_handler_field_preloader extends views_handler_field {
  function init(&$view, $options) {
    parent::init($view, $options);
    $schema = drupal_get_schema('files');
    foreach ($schema['fields'] as $field => $data) {
      $this->additional_fields[$field] = $field;
    }
  }
  
  function options_form(&$form, &$form_state) {
    parent::options_form($form, $form_state);
    $form['label']['#access'] = FALSE;
    $form['exclude']= array(
      '#type' => 'value',
      '#value' => TRUE,
    );
    $form['alter']['#access'] = FALSE;
    $form['empty']['#access'] = FALSE;
    $form['empty_zero']['#access'] = FALSE;
    $form['hide_empty']['#access'] = FALSE;
  }

  /**
   * Load & cache multiple file data.
   */
  function pre_render($values) {
    $schema = drupal_get_schema('files');
    foreach ($values as $value) {
      if (is_null($value->{$this->aliases['filepath']})) {
        continue;
      }
      $file = new stdClass();
      foreach ($schema['fields'] as $field => $data) {
        $file->$field = $value->{$this->aliases[$field]}; 
      }
      foreach (module_implements('file_load') as $module) {
        if ($module != 'field') {
          $function = $module .'_file_load';
          $function($file);
        }
      }
      _field_file_cache($file);
    }
  }
}
